#!/bin/bash
set -x 
###############################################################################
# default 0
# timeout 3
# showmenu 0
#   
# title Loongnix 20 SP1 GNU/Linux 4.19.0-loongson-3-desktop
#         kernel /dev/fs/ext2@wd0/boot/vmlinuz-4.19.0-loongson-3-desktop
#         initrd /dev/fs/ext2@wd0/boot/initrd-4.19.0-loongson-3-desktop.image
#         args console=tty loglevel=0 locales=zh_CN.UTF-8  splash quiet root=UUID=*8-*4-*4-*4-*12 resume=PARTUUID=*8-*4-*4-*4-*12
###############################################################################

root_mount_point=$1
swap_uuid=$2
kver=$(uname -r) 

[ -d "$root_mount_point" ] || exit 0

function sd2wd
{
    flag=-1
    index=0

    local sdpart=${1##*/}
    value=$(echo $sdpart | grep nvme)
    if [ $? -eq 0 ]
    then
        local disk=$(echo "$sdpart" | grep '[[:digit:]]\+' -o | head -n1)
        local order=$(echo "$sdpart" | grep '[[:digit:]]\+' -o | tail -n1)
	str1=-1
	flag=1
    fi

    value=$(echo $sdpart | grep -E 'sd|hd')
    if [ $? -eq 0 ];
    then
	str=`echo ${sdpart//[0-9]}`
	str1=`echo ${str:0-1}`	
        local order=$(echo "$sdpart" | grep '[[:digit:]]\+' -o | head -n1)
	flag=0
    fi

    for i in {a..z}
    do
        if [[ $str1 != -1 && "$str1" == "$i" ]];then
	    disk=$index
	fi

	((index++))

	if [ "$order" == "$index" ];then
	    part=$i
	fi
    done
	
    if [ $flag == 1 ]
    then 
    	wdpart="nvme$disk$part"
    else
	wdpart="wd$disk$part"
    fi

    echo $wdpart
}

entry=('title Loongnix 20 GNU/Linux %kver%'
       '    kernel /dev/fs/%fstype%@%wdx%/boot/vmlinuz-%kver%'
       '    initrd /dev/fs/%fstype%@%wdx%/boot/initrd.img-%kver%'
       '    args console=tty locales=zh_CN.UTF-8 splash quiet root=%rootdev% resume=%swapdev%')

boot_dir=$root_mount_point/boot
cfg_file=${boot_dir}/boot.cfg

[ -d "$boot_dir" ] || mkdir $boot_dir
[ -f "$cfg_file" ] || touch $cfg_file

root_dev=($(LANG= df $root_mount_point --output=source))
root_dev=${root_dev[1]}
root_uuid=$(blkid -o export $root_dev | grep ^UUID=)
boot_dev=($(LANG= df $boot_dir --output=source))
boot_dev=${boot_dev[1]}
boot_fstype=($(LANG= df $boot_dev --output=fstype))
boot_fstype=${boot_fstype[1]}
wd_boot=$(sd2wd $boot_dev)
swap_uuid=$(LANG= blkid -s UUID -s PARTUUID | grep $swap_uuid | awk '{print $3}' |sed 's/\"//g')

echo $boot_fstype

[ "$boot_fstype" = "vfat" ] && boot_fstype="fat"

title=${entry[0]/\%kver\%/$kver}
kernel=${entry[1]/\%fstype\%/$boot_fstype}
kernel=${kernel/\%wdx\%/$wd_boot}
kernel=${kernel/\%kver\%/$kver}
initrd=${entry[2]/\%fstype\%/$boot_fstype}
initrd=${initrd/\%wdx\%/$wd_boot}
initrd=${initrd/\%kver\%/$kver}
args=${entry[3]/\%rootdev\%/$root_uuid}
args=${args/\%swapdev\%/$swap_uuid}

if [ "$root_dev" != "$boot_dev" ]; then
    kernel=${kernel/'/boot'}
    initrd=${initrd/'/boot'}
fi

echo -e "\n" >>$cfg_file
echo "$title" >>$cfg_file
echo "$kernel" >>$cfg_file
echo "$initrd" >>$cfg_file
echo "$args" >>$cfg_file

